<?php
set_time_limit(0);
error_reporting(0);

define('IS_DEBUG', false);
define('IS_REDNET', false);
define('Q_DATE', date('Y-m-d H:00:00'));
define('Q_SOURCE','./Source/');
define('Q_XHTML', './xhtml/');

$chmlist = array();
$chmlist['csharp'] = array('index'=>'csharp/index','title'=>'C# 离线文档2018','Cname'=>'../csharp.chm');
$chmlist['msdn'] = array('index'=>'welcome','title'=>'MSDN 离线文档2018','Cname'=>'../msdn.chm');

// 以下内容请勿更新.
$keysel = OnceData('TypeSel');
if(!isset($chmlist[$keysel])){
   $keysel = 'csharp'; 
}

$sel = $chmlist[$keysel];
define('CHMINDEX', $sel['index']);
define('CHMTITLE', $sel['title']);
define('CHMNAME', $sel['Cname']);
define('DOC_SITE', 'https://docs.microsoft.com/zh-cn/dotnet/');
define('HHPNAME', Q_XHTML.'chm.hhp');
define('HHCNAME', Q_XHTML.'chm.hhc');
define('HHKNAME', Q_XHTML.'chm.hhk');
if(!isset($_GET['act']))
   $_GET['act'] = 'index';

$act = $_GET['act'];
if(!$_GET['go']){
  if($_GET['sel']){
     OnceData('TypeSel',$_GET['sel']);
     header('Location: ./index.php');
     exit(); 
  }
  showchmindex();
  exit();
}

echo '<style type="text/css">*{font-size:14px; background-color:ghostwhite;}</style>';
if($act === 'json'){
    echo '第一步执行结果: <br />';
    // 整个树型..
    $jsondata = getUrlData(DOC_SITE.'toc.json');
    if($jsondata){
        $jsondata = json_decode($jsondata,true);

        if($keysel === 'csharp'){ // 这是独立编译C# 指南.
            $newList[] = array('toc_title'=>$jsondata['items'][4]['toc_title'], 'href'=>$jsondata['items'][4]['href']);
            $List = $newList + $jsondata['items'][4]['children'];
        }else{
            $List = $jsondata['items'];
        }

        $tocJsonData = array();
        // 猎取下级json内容, 并且备份.
        GetallJsonData(json_encode($List),DOC_SITE,$tocJsonData);

        if(!$tocJsonData){
           exit('主json数据缺失, 请重试!! (正常的网络原因)'); 
        }else{
           echo '* 主json数据主层共有'.count($List).'层 <br>'; 
           echo '* 次级json链接共有'.count($tocJsonData).'条<br>';
        }

        // 取得所有的树型. 并且取得所有的html链接.
        $allhtmlurl = array();
        GgetAllchildren($List,DOC_SITE,$allhtmlurl);
        $cou = count($allhtmlurl); 
        if($cou > 0){
            $allhtmlurl = array_values($allhtmlurl);
            echo '* 共有html数量:'.$cou.'个<br>';
            echo '<span style="color:red">当前过程全部Ok, 可以进行下一步! </span><br /><br />';
        }else{
            echo '列表树重组失败? 这是严重的问题!!!<br />';
        }

        OnceData('_allhtmlurl',json_encode($allhtmlurl));
        OnceData('_allList',json_encode($List));
		OnceData('TestallList',var_export($List,true));
    }else{
        echo $indexurl.'读取失败, 一切均停止了<br>'; 
    }
}else if($act === 'html'){
    echo '第二步执行结果: <br />';
    $hhpimg = array();
    $allhtmlurl = json_decode(OnceData('_allhtmlurl'), true);
    if(!$allhtmlurl){
        echo '请先执行第一步!';
        exit();
    }

    $queryurl = array();
    foreach($allhtmlurl AS $key => $val){
        $queryurl[$key] = $val['url'];
    }
    // 切割成几个段来并发.
    $htmlurlList = array_chunk($queryurl,600,true);
    $errlist = $retok = array(); 
    foreach($htmlurlList AS $key => $val){
        $retDataList = getUrlData($val); // 请不要打印.内容大.
        $vals = array();
        foreach($retDataList AS $k => $v){
            if(!$v){
                // https://docs.microsoft.com/zh-cn/dotnet/csharp/programming-guide/types/ 官网也有一条不存在.
                // var_dump($allhtmlurl[$k]);
                // exit();
               $errlist[] = 'ret:'.strlen($v).' url:'.$val[$k];
            }else{
               $retok[] = strlen($v);
            }
        }
    }
    
    echo '* 共有html数量:'.count($allhtmlurl).'个<br>';
    echo '* 缓存结果: 成功['.count($retok).'] 失败['.count($errlist).']<br />';
    if(count($errlist) < 1){
       echo '全部缓存成功!:<br>';
    }

    $allimgurl = array(); // 所有的图片链接.
    // 让html符合自已所想. 并且目录结构正常.
    if(count($errlist) < 50){
        $fwcount = $err2list = array();
        foreach($allhtmlurl AS $val){
            $redata = getFileData(Q_SOURCE.'html/'.md5($val['url']));
            $local = Q_XHTML.$val['local'];

            if(!$redata){
               file_force_putData($local, $val['url'].' - 404?'); //默认的404?
               $err2list[] = $val['url']; 
               continue;
            }
            
            // 这儿.
            $redata = parse_html($redata,$val);
            $redata = strtr($redata, array('*DIR*/'=>'/'));
            if(is_file($local) && md5_file($local) === md5($redata)) {
               continue;
            }

            $fwcount[] = $local.'-W-'.strlen($redata).'=='.$val['url'];
            file_force_putData($local,$redata);
        }
        // 图片采集在这儿.
        if($allimgurl){
            $urlarr = array();
            foreach($allimgurl AS $k => $v){
                $urlarr[$k] = $v['url'];
            }

            $retDataList = getUrlData($urlarr);
            echo '<br>* 图片链接共有'.count($allimgurl).'条<br />';
            $errimg = array();
            foreach($allimgurl AS $key => $val){
                $imgData = $retDataList[$key];
                if(!$imgData){
                    $errimg[$key] = $val;
                }else{
                    file_force_putData(Q_XHTML.$val['local'], $imgData);
                    $hhpimg[] = $val['local'];
                }
            }
            if($errimg){
               echo '* 图片同步失败列表'.count($errimg).':<br /><pre>';
               print_r($errimg);
            }else{
               echo '* 图片同步全部成功<br />';
            }
            
        }

        echo '<br />文件重组结果: 写入成功['.count($fwcount).'] 失败['.count($err2list).']<br />';
        echo '<span style="color:red">整个过程全部Ok, 可以进行下一步! </span><br />';
    }else{
        echo '缓存失败文件超过50时, 本地重组将不会进行!!, 请先继续操作缓存!!!<br>';
    }

    if($errlist > 1){
        echo '<br>远程抓取失败的列表: <br /><pre>';
        print_r($errlist);

        echo '本地缓存重组失败列表: <br />';
        print_r($err2list);
    }

    if(count($fwcount) > 0){
        echo '缓存成功列表一部分(多次刷新不应该出现这个??):<br /> <pre>';
        print_r(array_splice($fwcount,0,100));
    }

    OnceData('_imgUrllist',json_encode($hhpimg)); 
    OnceData('fwallhtml',var_export($fwcount,true));
}else if($act === 'chm'){
    echo '第三步执行结果: <br />';
    // 生成编译chm所需要的文件
    put_data(HHPNAME, '');
    put_data(HHCNAME, '');
    put_data(HHKNAME, '');

    put_data(HHPNAME, hhpinfo());
    put_data(HHCNAME, hhcinfo());
    put_data(HHKNAME, hhkinfo());

    $imglist = json_decode(OnceData('_imgUrllist'), true);
    $List = json_decode(OnceData('_allList'), true);
    if($List){
        $RetList = array();
        creChmlist($List,DOC_SITE); // 全部在这里面搞定.
        copy('style.css', Q_XHTML.'style.css');
        foreach($imglist AS $val){
        put_data(HHPNAME,$val."\n");
        }
        put_data(HHPNAME, 'style.css');

        echo 'CHM配置文件生成成功 OK<pre>';
        print_r(array_splice($RetList['index'],0,100));
    }else{
        echo '无法生成CHM 配置文件';
    }
}else if($act === 'xparse'){
    $val = array();
    if($_GET['idx']){ 
      $val = json_decode(OnceData('_xparseidx'),true);
   }  
   
   if(!$val){
     $allhtmlurl = json_decode(OnceData('_allhtmlurl') ,true);
     shuffle($allhtmlurl);
     $val = $allhtmlurl[0];
   }
   
   // 每次都保存一份当前的值.
   OnceData('_xparseidx', json_encode($val));
   
   $redata = getFileData(Q_SOURCE.'html/'.md5($val['url']));
   $d =  parse_html($redata, $val);

   copy('style.css', Q_XHTML.'style.css');
   $d = strtr($d, array('*DIR*/'=>''));
   file_put_contents(Q_XHTML.'demo.html', $d);
   header('Location: '.Q_XHTML.'demo.html');
}else if($act === 'index'){
   echo '* 当前网络与微软文档中心的连接状态：'.currstatus().'<br /><br />'; 
   echo '* 本功能主要是生成msdn的离线文档chm<br />';
   echo '* 请依顺序一步一步执行，尽可能看到红色ok字样再下一步<br />';
   echo '* 步骤中有可能连接微软文档中心，根据网络情况， 速度未知， 结果未知，请注意看结果集<br />';
   echo '* 随机测试html重组, 仅限调试界面样式时使用, 里面的链接均不可正常点击(这并不会影响真正的html)<br />';

   echo '<br /><br />建议, 反馈信息交给QQ104979058';
}else if($act === 'cre'){
    echo '第四步执行结果: <br />';
    echo '最后编译工作需要 HTML Help Workshop 来完成, 请下载并安装<a href="https://docs.microsoft.com/zh-cn/previous-versions/windows/desktop/htmlhelp/microsoft-html-help-downloads">Download Htmlhelp.exe</a>';
    echo '<br />当前编译源文件路径为:'.realpath(HHPNAME).'<br />';
    echo '<br />演示一段操作:<br />';
    echo '<img src="helpcre.gif" /><br />';
    echo '等待完成后, 在'.__DIR__.'目录就可以看到'. basename(CHMNAME).'文件了.';
}


// 以下全部是函数.

function OnceData($key, $data =''){
   $path = Q_SOURCE.$key; 
   if(!$data){
      return getFileData($path);
   }else{
      return file_put_contents($path, $data); 
   }
}

function currstatus(){
  static $state;  
  if($state)
    return $state;
  $ch = curl_init();   
  curl_setopt($ch, CURLOPT_URL, DOC_SITE);   
  curl_setopt($ch, CURLOPT_TIMEOUT, 10);
  curl_setopt($ch, CURLOPT_USERAGENT, 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.6756.400 QQBrowser/10.3.2565.400'); 
  curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 8);   
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
  curl_setopt($ch, CURLOPT_HTTPHEADER, array('X-FORWARDED-FOR:'.Rand_IP(), 'CLIENT-IP:'.Rand_IP()));
  curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
  curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
  curl_exec($ch);
  $ret = curl_getinfo($ch);
  $ret = $ret['http_code'].'-'.$ret['content_type'];

  $state = htmlspecialchars($ret);
  if(strpos($state,'200') === false){
    $state = '<a style="color:red">'.$qret[0].'</a>';
  }
  return $state;
}

function GetallJsonData($Data, $fdurl, &$list){
   static $iserr = false; 
   // 取得整个json段及下段的所有json. 
   preg_match_all('/"tocHref"\:"([^"]*\.json)"/isU', $Data, $eg);
   $listurl = array();
   foreach($eg[1] AS $val){
        $val = strtr($val, array('\\'=>''));
        $jurl = $fdurl.$val;
        $listurl[$jurl] = $jurl;
   }

   $listurl = getUrlData($listurl);
   foreach($listurl AS $key => $val){
        if(!$val){
           $iserr = true;
           break;
        }

        $list[$key] = $val;
        preg_match('/"tocHref"\:"([^"]*\.json)"/isU', $val, $eg);
        if(isset($eg[1]) && $eg[1]){
           GetallJsonData($val, dirname($key).'/', $list); 
        }
   }
   if($iserr){
      $list = array();
   }
}

function getList($url) {
    global $tocJsonData;
    if(!$tocJsonData[$url]){
        echo $url.'丢失?<br>';
        exit();
    }

    $jsondata = json_decode($tocJsonData[$url],true);
    if(is_array($jsondata['items'])){
        // 说明是一层.
        if($jsondata['items'][0]['href'] === './' && $jsondata['items'][0]['children']){
            $jsondata['items'] = $jsondata['items'][0]['children'];
        }
        return $jsondata['items'];
    }else{
        exit('无法访问:'.$url);
    }
}

function GgetAllchildren(&$list = array(), $fdurl='', &$allhtmlurl){
    $fdurl = trim($fdurl,'/').'/';
    foreach($list AS $key => &$val){
         // 移除某些项.
        $item = explode('/',$val['href']);
        if(strpos($val['href'], '..') !== false){
            foreach($item AS $k=> $v){
                if($v === '..'){
                   unset($item[$k]);
                }
            }
            $val['href'] = implode('/',$item);
            $fdurl = DOC_SITE;
        }
        // 计算出当前需要的父辈.
        $val['topfaterurl'] = $fdurl;

        // 计算出当前链接及目录结构.
        if($val['href']){
            if($val['href'] === './'){
                $val['href'] = ''; 
            }
            if($val['href'][0] === '/'){
               // 主页?  
               $val['topfaterurl'] = dirname(DOC_SITE); 
            }

            $val['currUrl'] = $val['topfaterurl'].$val['href']; // 组成当前可访问.
            
            // 还有一种直接url的? 
            if(strpos($val['href'], '://') !==false){
               $val['currUrl'] = $val['href'];
               $val['Localfile'] = 'github/'.md5($val['currUrl']);
            }else{
                //同时影响下层.
                $val['currUrl'] = strtr($val['currUrl'],array('call-duration'=>'calls-duration')); 
                $val['currUrl'] = preg_replace('/\?.*$/isU','',$val['currUrl']);
                preg_match('/zh-cn\/(.*\/)?([^\/]*)/is',$val['currUrl'], $reg);  //未必能够取得需要的路径值.
                $val['Localfile'] = trim($reg[1]);
                $val['Localfile'] = strtr($val['Localfile'], array('dotnet/'=>'')); // dotnet是根目录, 需要过滤掉.

                $fname = trim($reg[2]);
                if(!$fname){
                   $fname = 'index';
                   $val['currUrl'] .= $fname;
                }

                $val['Localfile'] .= $fname;
            }

            // 互操作性
            //释放出所有文件. 主要为解析本地文件作准备.
            $allhtmlurl[$val['currUrl']] =  array('url'=>$val['currUrl'], 'local'=>$val['Localfile'], 'title'=>$val['toc_title']);
        }

        $val['nextfaterurl'] = $fdurl;
        if($val['tocHref']){
           $val['nextfaterurl'] = $fdurl.dirname($val['tocHref']).'/';  //下次的
           $val['tocHref'] = $val['topfaterurl'].$val['tocHref'];  // 组成完整的url值.
           $val['children'] = getList($val['tocHref']);
        }

        if(is_array($val['children'])){           
            GgetAllchildren($val['children'], $val['nextfaterurl'], $allhtmlurl);
            $val['Lchildren'] = $val['children'];
            unset($val['children'],$val['tocHref']);
        }

        if(!IS_DEBUG){
           unset($val['tocHref'], $val['nextfaterurl'], $val['topfaterurl'], $val['href']);
        }
    }
}

function creChmlist(&$list = array(), $fdurl=''){
    static $onlyList;
    global $RetList;
    $fdurl = trim($fdurl,'/').'/';
    put_data(HHCNAME, "<UL>\n");
    foreach($list AS $key => $val){
        // 写入文件列表hhp.
        $Localfile = $val['Localfile'];

        // 有本地文件的才写入chm索引内容.
        if($val['Localfile']){
            if(!$onlyList[$Localfile]){
               put_data(HHPNAME,$Localfile."\n"); 
            }
            $onlyList[$Localfile] = 1;

            // 索引, 非唯一. 相同路径可能有两个标题.
            put_data(HHKNAME,'<LI><OBJECT type="text/sitemap"><param name="Name" value="'.$val['toc_title'].'">'.
            '<param name="Local" value="'.$Localfile.'">'.
            '</OBJECT></LI>'."\n");

            $RetList['index'][] = "$Localfile,{$val['toc_title']}";
            
            $imgn = 11;
            if(is_array($val['Lchildren'])){
               $imgn = 1; 
            }

            $RetList['imgn'][] = $imgn;
            
            // 左侧树.
            put_data(HHCNAME,'<LI><OBJECT type="text/sitemap"><param name="ImageNumber" value="'.$imgn.'"><param name="Name" value="'.$val['toc_title'].'">'.
            '<param name="Local" value="'.$Localfile.'">'.
            '</OBJECT></LI>'."\n");
        }

        if(is_array($val['Lchildren'])){          
           creChmlist($val['Lchildren'], $val['nextfaterurl']);
        }
    }
    put_data(HHCNAME, "</UL>\n");
    $RetList['Filelist'] = $onlyList;
}

function parse_html($html, $fdinfo = array()){
    global $allimgurl;
    $isTest = ($_GET['act'] === 'xparse');
    if(!$html)
      return $html;

    $html = preg_replace('/\<\!\-\-.*\-\-\>/isU','',$html);
    // 标题.
    preg_match('/\<meta property\="og\:title" content\="([^"]*)"/isU', $html, $reg);
    $title = $reg[1];

    // 解析主html 
    preg_match('/\<main id\="main".*\<\/main\>/isU', $html, $reg);
    $html = $reg[0];  // 这是主线.

    $html = preg_replace('/\<span class\="sxs-lookup".*\<\/span\>/isU','', $html);
    // 整理作者
    $html = preg_replace_callback('/\<ul class\="metadata page-metadata".*\<\/ul\>.*\<\/ul\>/isU',function ($m){
        preg_match_all('/\<li\>\<a href\="([^"]*)" title\="([^"]*)" data\-bi\-name.*img.*\<\/li\>/isU',$m[0], $reg);
        foreach($reg[1] AS $k => $v){
            $reg[1][$k] = sprintf('<a href="%s">%s</a>', $v, $reg[2][$k]);
        }
        return '<div>作者: '. implode(', ',$reg[1] ).'</div>'; 
    },$html);
    
    $curDir = dirname($fdinfo['local']);
    if($curDir)
       $curDir = rtrim($curDir,'/').'/';

    // 本地链接是否可点击, 需要在这儿处理.
    $html = preg_replace_callback('/href="([^"]*)"/isU',function ($m)use($curDir){
        $opennew = 'class="local"';
        $Tx = explode('?',$m[1]);
        $m[1] = $Tx[0];

        $Tx = explode('#',$m[1]);
        $thisurl = $Tx[0];
        if(strpos($m[0], 'href="http') !== false){
            $opennew = 'class="httpnet" target="_blank"';
        }else if($thisurl !== ''){
            $temcurDir = Q_XHTML.$curDir;
            $thisurl = strtr($thisurl, array('dotnet/'=>'','zh-cn/'=>''));
            if(!is_file(Q_XHTML.$thisurl)){
                if(!is_file($temcurDir.$thisurl)){
                    // 记录无法匹配上的链接.
                    $opennew = ' class="localnot"';
                    $isnot = true;
                }
            }
        }
        
        if($isnot){
            return sprintf('%s',$opennew);
        }else{
            return sprintf('%s title="%s" href="%s"',$opennew,$m[1],$m[1]); 
        }
    },$html);
    $html = preg_replace('/<span[^>]*>/isU','<span>',$html);
    $html = preg_replace_callback('/>([^<]*)</isU',function($m){
        $m[1] = trim($m[1]);
        return ">$m[1]<";
    }, $html);

    // 过滤字符
    $html = preg_replace_callback('/<(h[1-6]{1})[^>]*>(.*)<\/h[1-6]{1}>/isU',function($m){
        $m[2] = strip_tags($m[2]);
        return "<{$m[1]}>{$m[2]}</{$m[1]}>";
    }, $html);
    
    $html = preg_replace('/<nav[^>]*>/isU','',$html);
    $html = preg_replace('/<main[^>]*>/isU','',$html);
    $html = strtr($html, array('</nav>'=>'','</main>'=>'','<br>'=>'<br />','hidden=""'=>''));
    $html = preg_replace('/<div class\="tutorial\-card\-header.*<\/div>/isU','',$html);
    $html = preg_replace('/<div class\="tutorial\-card .*<\/div>/isU','',$html); 
    $html = preg_replace('/<p class\="tutorial-step-meta.*<\/p>/isU','',$html); 
    $html = preg_replace('/class\="tutorial\-row"><div class\="tutorial\-row\-main"><a.*<\/div>/isU','',$html);
    
    // 添加test数据
    if($isTest){
        $info = '';
        foreach($fdinfo AS $key => $val){
            $info .= "$key:$val\n\r";
        }
        $testinfo = "\n\r<!-- TestInfo:\n\r$info-->\n\r";
    }

    // 图片地址 ok
    $html = preg_replace_callback('/<img[^>]*src="([^"]*)"/isU',function ($m)use(&$allimgurl, $fdinfo){
        $souurl = trim($m[1]);
        $souurl = preg_replace('/\?.*$/isU','',$souurl);
        
        if(strpos($souurl, '://') === false){
           $topurl = dirname($fdinfo['url']); 
           if(stripos($souurl, 'visual-studio-tools-for-docker') !== false){
               $topurl = dirname($topurl);
               $topurl .= '/host-and-deploy/docker';
           }else if( (stripos($fdinfo['url'], 'framework/wcf/') !== false || stripos($fdinfo['url'], 'windows-workflo') !== false) && strpos($souurl, '%') !== false ){
               $topurl = 'https://docs.microsoft.com/zh-cn/previous-versions/dotnet/netframework-4.0';
               //$souurl = strtr($souurl, array('en-us'=>'zh-cn'));
           }
           $imgurl = $topurl.'/'.$souurl; //图片后面下载, 先处理好
        }else{
           $imgurl = $souurl;
        }

        $imgmd5 = md5($imgurl);
        $tem = explode('.',$souurl);
        $c = array_pop($tem);
        if(!$c){
           return $m[0];
        }

        $allimgurl[$imgmd5] = array('url'=>$imgurl,'local'=>"qwimg/$imgmd5.$c",'fx'=>$c, 'sou'=>$m[1],'Data'=>json_encode($fdinfo)); 
        return sprintf('<img src="%s"','/'.$allimgurl[$imgmd5]['local']);
   },$html);

    // 源码用php先简单高亮 ok.
    $html = preg_replace_callback('/\<pre\>\<code([^\>]*)\>(.*)\<\/code\>/isU',function ($code){
        $xcode = trim($code[2]);

        if(strpos($code[1],'lang-csharp') === false)
            $xcode = '';
        
        if($xcode){
            $xcode = htmlspecialchars_decode($xcode,ENT_QUOTES);  
            $xcode = strtr($xcode, array('\"'=>'11##"'));  
            $xcode = highlight_string("<?php \n".$xcode, true);
            $xcode = strtr($xcode, array('&lt;?php&nbsp;<br />'=>'','11##"'=>'\"'));
        }else{
            return $code[0]; 
        }
        return '<pre>'.trim($xcode);
    },$html);

    return '<!DOCTYPE HTML>
    <head>
      <meta charset="utf-8" />
      <meta http-equiv="X-UA-Compatible" content="IE=edge" />
      <title>'.$title.'</title>
      <link rel="stylesheet" href="*DIR*/style.css" />
      </head>'.$testinfo.'<body><div id="chmain">'.$html.'<hr /><span class="footer">编译:Tuesday[104979058] 位于深圳于香港之间. UTC: '.Q_DATE.'</span>
      </div></body></html>';
}

function hhkinfo(){
    // 索引.
    return '<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML//EN">
    <HTML>
    <HEAD>
    <meta name="GENERATOR" content="Microsoft HTML Help Workshop 4.74">
    </HEAD>
    <BODY>
    <OBJECT type="text/site properties">
    <param name="comment" value="title:索引">
    </OBJECT>
    <UL>';
}

function hhcinfo(){
    // 树结构.
    return '<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML//EN">
    <HTML>
    <HEAD>
    <meta name="GENERATOR" content="Microsoft HTML Help Workshop 4.74">
    </HEAD>
    <BODY>
    <OBJECT type="text/site properties">
    <param name="Window Styles" value="0x800025">
    <param name="comment" value="title:树结构">
    <param name="comment" value="base:'. CHMINDEX .'">
    </OBJECT>';
}

function hhpinfo(){
$str = '[OPTIONS]
Compatibility=1.1 or later
Compiled file='.CHMNAME.'
Contents file='. basename(HHCNAME) .'
Index file='. basename(HHKNAME).'
Default Window=phpdoc
Default topic='.basename(HHCNAME).'
Display compile progress=Yes
Full-text search=Yes
Language=0x804 Simplified Chinese
Title='.CHMTITLE.'
Default Font=simsun,10,0

[WINDOWS]
phpdoc="'.CHMTITLE.'",'.basename(HHCNAME).','.basename(HHKNAME).','.CHMINDEX.','.CHMINDEX.',,,,,0x23520,,0x386e,,,,,,,,0
[FILES]
';
return $str;
}

function put_data($file, $str){
    if(!$str && is_file($file)){
       unlink($file);
       return true;
    }

    $str = mb_convert_encoding($str,'gbk','utf-8');
    file_put_contents($file, $str,FILE_APPEND);
}

function getUrlData($url = array(),$func=''){
    if(!$url)
       return '';
    
    $once = false;
    if(!is_array($url)){
       $once = true;
       $url = array($url);
    }

    $vals = array_values($url);
    if(stripos($vals[0], '.json') !== false){
       $dirpath = Q_SOURCE.'json/'; 
    }else{
       $dirpath = Q_SOURCE.'html/'; 
    }

    $urlqueryData = array(); 
    foreach($url AS $key => $val){
        $key = trim($key);
        $urlkey = trim(strtr($val,array('\\'=>'')));
        $temFwfile = $dirpath.md5($urlkey);
        $wd = getFileData($temFwfile);
        if($wd){
          $urlqueryData[$key] = $wd;
          if(!IS_REDNET){
             unset($url[$key]);
          }
        }
    }

    // 缓存没有继续直接取.
    if($url){
        $urlret = getQueryUrl($url, $func);
        foreach($urlret AS $key => $Data){
            $key = trim($key);
            $urlkey = trim(strtr($url[$key],array('\\'=>'')));
            $temFwfile = $dirpath.md5($urlkey);
            // 空?  404?
            if(!$Data){
                $Data = getFileData($temFwfile);
            }else{
                if(!file_force_putData($temFwfile, $Data)){
                   echo $temFwfile.'FW ERR'."<Br />";
                }
            }
            $urlqueryData[$key] = $Data;
        }
    }

    if($once){
       return $urlqueryData[0];
    }else{
       return $urlqueryData; 
    }
}

function file_force_putData($dir, $contents){
    $sdir = $dir;
    $dir = ltrim($dir,'./');
    $parts = explode('/', $dir);
    $file = array_pop($parts);
    $dir = __DIR__;
    foreach($parts as $part){
        $dir .= "/$part";
        if(!is_dir($dir)) mkdir($dir);
    }

   if($contents){
        return file_put_contents($sdir, $contents);
   }else{
       return 0;
   }
}

function getFileData($filepath){
    if(is_file($filepath)){
       return trim(file_get_contents($filepath)); 
    }
    return '';
}

function getQueryUrl($chList = array(),$func=''){     
    $ret = array(); 
    $mh = curl_multi_init();
     foreach ($chList as $i => $url) {
        $ret[$i] = '';
        $hand = curlPost($url);
        $ch[intval($hand)] = $i;
        curl_multi_add_handle($mh,$hand);
    }

    do {
      while (($status = curl_multi_exec($mh, $active)) == CURLM_CALL_MULTI_PERFORM) ;
      if ($status != CURLM_OK) {
          break;
      }
      $done = curl_multi_info_read($mh);
      if($done){
          $ids = $ch[intval($done['handle'])];
          $retcode = curl_getinfo($done['handle'],CURLINFO_HTTP_CODE);
          if($retcode === 200){
             $ret[$ids] = curl_multi_getcontent($done['handle']);
          }
          curl_multi_remove_handle($mh, $done['handle']);
          if($func){
             call_user_func_array($func,array($retcode,$ret[$ids]));
          }
      }
      // 当没有数据的时候进行堵塞，把 CPU 使用权交出来，避免上面 do 死循环空跑数据导致 CPU 100%
    if ($active) {
        $rel = curl_multi_select($mh, 1);
        if($rel == -1){
           usleep(1000);
        }
    }

    if($active == false){break;}
    } while ($status === CURLM_CALL_MULTI_PERFORM || $active);
    curl_multi_close($mh);
    return $ret;
}

function Rand_IP(){
    $ip2id= round(rand(600000, 2550000) / 10000); //第一种方法，直接生成
    $ip3id= round(rand(600000, 2550000) / 10000);
    $ip4id= round(rand(600000, 2550000) / 10000);
    //下面是第二种方法，在以下数据中随机抽取
    $arr_1 = array("218","218","66","66","218","218","60","60","202","204","66","66","66","59","61","60","222","221","66","59","60","60","66","218","218","62","63","64","66","66","122","211");
    $randarr= mt_rand(0,count($arr_1)-1);
    $ip1id = $arr_1[$randarr];
    return $ip1id.".".$ip2id.".".$ip3id.".".$ip4id;
}

// 请不要直接调用此函数.
function curlPost($url, $timeout = 20){   
    $ch = curl_init();   
    curl_setopt($ch, CURLOPT_URL, $url);   
    curl_setopt($ch, CURLOPT_TIMEOUT, $timeout);
    curl_setopt($ch, CURLOPT_USERAGENT, 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.6756.400 QQBrowser/10.3.2565.400'); 
    curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $timeout-2);   
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_REFERER, dirname($url));//模拟来路
    curl_setopt($ch, CURLOPT_HTTPHEADER, array('X-FORWARDED-FOR:'.Rand_IP(), 'CLIENT-IP:'.Rand_IP()));
    if(stripos($url,'https') === 0){
       curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
       curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
     }
     if ((ini_get('open_basedir') == '') && (ini_get('safe_mode') == 'Off' || !ini_get('safe_mode'))){
         curl_setopt($ch,CURLOPT_FOLLOWLOCATION,1); // 302 redirect
         curl_setopt($ch,CURLOPT_MAXREDIRS,7);
    }
    curl_setopt($ch, CURLOPT_HTTPHEADER, array('Expect:')); //避免data数据过长问题   
    return $ch;
}

function showchmindex(){
    global $keysel;
$x = microtime(true);
$msdncss = $csharpcss = '';
if($keysel === 'msdn'){
    $msdncss = ' style="color:red"'; 
}else{
    $csharpcss = ' style="color:red"';
}
?>
<!DOCTYPE HTML>
<html>
<head>
    <meta charset="utf-8" />
	<meta http-equiv="content-type" content="text/html" />
	<meta name="author" content="www.atuser.com" />
	<title>MSDN 手册生成解析器</title>
    <style type="text/css">
        span{ background-color: #E5E5E5; border: 1px solid gray;margin-right:10px; padding: 8px;}
    </style>
</head>

<body style="font-size: 12px; line-height:2em;padding:0px;margin:0px">
<div style="margin: 30px; margin-bottom:0px;">
    <h3 style="clear: both;">
    <div>MSDN 全手册制作教程 / <a href="./">首页</a> / <a<?php echo $msdncss;?> href="./index.php?sel=msdn">整个MSDN</a> / <a<?php echo $csharpcss;?> href="./index.php?sel=csharp">单独C#</a></div>
    </h3>
    <div style="clear: both; margin:5px; width: 800px;">
        <span><a href="./index.php?act=json">第一步读取整个MSDN树</a></span>
        <span><a href="./index.php?act=html">第二步缓存全部html</a></span>
        <span><a href="./index.php?act=chm">第三步生成编译文件</a></span>
        <span><a href="./index.php?act=cre">第四步手册编译工作</a></span>
        <span><a href="./index.php?act=xparse">随机测试</a>　/　<a href="./index.php?act=xparse&idx=1">刷新当前</a></a></span>
    </div> 
    <?php if($_GET['act']){ ?> 
    <div>结果集::<br />
    <iframe src="./index.php?act=<?php echo $_GET['act'];?>&idx=<?php echo $_GET['idx'];?>&go=<?php echo $x;?>" style="width:80%; font-size: 12px;height: 680px; border: none; border: 1px solid silver;">
    </iframe><br />
    * 执行时间有点长, 请耐心等候!!!<br />
    * 点击<a target="_blank" href="<?php echo DOC_SITE;?>">链接</a>检测是否已经被微软阻止访问了(通常这种情况, 需要换网络)<br />
    </div>
    <?php } ?>
    </body>
</html>
<?php
}